#!/usr/bin/perl
#------------------------------------
# waitpid_test2.pl
use POSIX ":sys_wait_h";
our $zombies = 0;                 # 记录系统中僵尸进程的数目
$SIG{CHLD} = sub { $zombies++ };  # 信号处理程序中仅仅统计僵尸进程数目

sub REAPER {
  my $pid;
  while (($pid = waitpid(-1, WNOHANG)) > 0) {
    # 进行一些处理
    $zombies--;
  }
}

sub child {
  print "I'm child, pid=$$.\n";
}

while (1) {
  if (fork() == 0) {
    &child;    # 如果当前进程是子进程，则执行 child 函数
	exit;      # 并退出
  } else {
    &REAPER if $zombies;
    sleep 5;   # 如果是父进程，则睡眠 5 秒
  }
}

